<?php

namespace App\Livewire\Studio\Manage\Article;

use App\Jobs\StorePushNotification;
use App\Livewire\Forms\Studio\Manage\ArticleForm;
use App\Models\PushNotification;
use App\Traits\WithAuthorization;
use App\Traits\WithToast;
use App\Traits\WithUpdatedData;
use Illuminate\Support\Str;
use Livewire\Attributes\Title;
use Livewire\Component;

#[Title('Tambah Artikel')]
class Create extends Component
{
    use WithAuthorization, WithToast, WithUpdatedData;

    public ArticleForm $form;

    public function save()
    {
        $this->canOrAbort('create article');

        $result = $this->form->store();

        StorePushNotification::dispatch(
            PushNotification::all(),
            [
                'title' => '📝 Artikel Baru!',
                'body' => Str::limit($result, 50).' '.' ✨ Yuk baca selengkapnya di aplikasi!',
            ],
        );

        $this->dispatch('refreshDatatable');

        $this->toast('Artikel berhasil ditambahkan.');

        $this->redirectRoute('studio.manage.article.index');
    }

    public function render()
    {
        return view('livewire.studio.manage.article.form', [
            'pageTitle' => 'Tambah Artikel',
        ]);
    }
}
